
Extended Fields - Patch #2172

Отстутствие ссылок для типа link

13 Mar 2013 20:30 - Александр Гремячкин

Status: Closed Start date: 13 Mar 2013

Priority: Normal Due date: 03 Jun 2013

Assignee: Andriy Lesyuk % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 0.2.2   

Redmine version:  External issue:  

Description

source:app/helpers/extended_fields_helper.rb

         filename = custom_field.name.gsub(%r{[^a-z0-9_]+}i, '_').downcase

         filename.gsub!(%r{(^_+|_+$)}, '')

-        unless filename.empty?

-            format_extension = ''

-            # Redmine 2.x.x

-            if respond_to?(:formats)

-                format_extension = ".#{formats.first}" 

+        format_extension = ''

+        # Redmine 2.x.x

+        if respond_to?(:formats)

+            format_extension = ".#{formats.first}" 

+        # Redmine 1.x.x

+        elsif request && request.respond_to?(:template_format)

+            format_extension = ".#{request.template_format}" 

+        # Mailer

+        elsif controller

             # Redmine 1.x.x

-            elsif request && request.respond_to?(:template_format)

-                format_extension = ".#{request.template_format}" 

-            # Mailer

-            elsif controller

-                # Redmine 1.x.x

-                if controller.respond_to?(:template)

-                    format_extension = ".#{controller.template.template_format}" 

-                # Redmine 2.x.x

-                elsif controller.respond_to?(:lookup_context)

-                    format_extension = ".#{controller.lookup_context.formats.first}" 

-                end

+            if controller.respond_to?(:template)

+                format_extension = ".#{controller.template.template_format}" 

+            # Redmine 2.x.x

+            elsif controller.respond_to?(:lookup_context)

+                format_extension = ".#{controller.lookup_context.formats.first}" 

             end

-

-            self.view_paths.each do |load_path|

-

                if template = load_path["custom_values/#{custom_field.field_format}/_#{filename}#{

format_extension}"]

+        end

+        unless filename.empty?

+            self.view_paths.each do |load_path|

+

                if template = load_path["custom_values/#{custom_field.field_format}/_#{filename}#{

format_extension}"]

                     return "custom_values/#{custom_field.field_format}/#{filename}" 

                 end
             end

-

-            self.view_paths.each do |load_path|

-

                if template = load_path["custom_values/common/_#{custom_field.field_format}#{forma

t_extension}"]

-                    return "custom_values/common/#{custom_field.field_format}" 

-                end

+        end

+        self.view_paths.each do |load_path|

+

            if template = load_path["custom_values/common/_#{custom_field.field_format}#{format_ex

tension}"]

+                return "custom_values/common/#{custom_field.field_format}" 

             end

         end

 

для типа link custom_field.name пустое

Related issues:

Related to Extended Fields - Bug #2155: Wiki text field donot work well when ... Incomplete 28 Feb 2013

Associated revisions

Revision 90 - 03 Jun 2013 09:23 - Andriy Lesyuk

Applied patch for #2172, updated CREDITS

History

#1 - 13 Mar 2013 20:56 - Александр Гремячкин

или покороче

@    def find_custom_field_template(custom_field)

        filename = custom_field.name.gsub(%r{[^a-z0-9_]+}i, '_').downcase

        filename.gsub!(%r{(^_+|_+$)}, '')

        unless filename.empty?

            format_extension = ''

            # Redmine 2.x.x

            if respond_to?(:formats)

                format_extension = ".#{formats.first}" 

            # Redmine 1.x.x

            elsif request && request.respond_to?(:template_format)

                format_extension = ".#{request.template_format}" 

            # Mailer

            elsif controller

                # Redmine 1.x.x

                if controller.respond_to?(:template)

                    format_extension = ".#{controller.template.template_format}" 

                # Redmine 2.x.x

                elsif controller.respond_to?(:lookup_context)

                    format_extension = ".#{controller.lookup_context.formats.first}" 

                end

            end

            self.view_paths.each do |load_path|

                if template = load_path["custom_values/#{custom_field.field_format}/_#{filename}#{format_exten

sion}"]

                    return "custom_values/#{custom_field.field_format}/#{filename}" 

                end

            end

            self.view_paths.each do |load_path|

                if template = load_path["custom_values/common/_#{custom_field.field_format}#{format_extension}

"]

                    return "custom_values/common/#{custom_field.field_format}" 

                end
            end

        end

        nil

    end@

 

на

@    def find_custom_field_template(custom_field)

        filename = custom_field.name.gsub(%r{[^a-z0-9_]+}i, '_').downcase

        filename.gsub!(%r{(^_+|_+$)}, '')

        format_extension = ''

        # Redmine 2.x.x

        if respond_to?(:formats)

            format_extension = ".#{formats.first}" 

        # Redmine 1.x.x

        elsif request && request.respond_to?(:template_format)

            format_extension = ".#{request.template_format}" 

        # Mailer

        elsif controller

            # Redmine 1.x.x

            if controller.respond_to?(:template)

                format_extension = ".#{controller.template.template_format}" 

            # Redmine 2.x.x

            elsif controller.respond_to?(:lookup_context)

                format_extension = ".#{controller.lookup_context.formats.first}" 

            end

        end        

        unless filename.empty?

            self.view_paths.each do |load_path|                

                if template = load_path["custom_values/#{custom_field.field_format}/_#{filename}#{format_exten

sion}"]                    

                    return "custom_values/#{custom_field.field_format}/#{filename}" 

                end

            end

        end

        self.view_paths.each do |load_path|            

            if template = load_path["custom_values/common/_#{custom_field.field_format}#{format_extension}"]  

              

                return "custom_values/common/#{custom_field.field_format}" 

            end

        end

        nil

    end@
#2 - 25 May 2013 21:51 - Andriy Lesyuk

- Status changed from New to Under Verification

- Target version set to 0.2.2

Спасибо!

#3 - 03 Jun 2013 09:24 - Andriy Lesyuk

- Due date set to 03 Jun 2013

- Status changed from Under Verification to Closed

- % Done changed from 0 to 100
